//+------------------------------------------------------------------+
//|                                                   e_fisherman.mq4|
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+


#include <WinUser32.mqh>

extern bool Buy = true  ; //  true -  
extern bool Sell = true  ; // true -  
extern bool Manual = false; // . ( ,  - ) 
extern bool MWMode = false; //-      
                            //   ( StopLoss  TakeProfit)
                            //   
extern string BeginSession="01:00"; //-      (GMT)
extern string EndSession  ="01:00";   //-       (GMT)
//     (   )    . 
//  BeginSession   EndSession ,      .
//======================================    ==========================
extern double Lots    = 0.1;    //  
extern double MaxRisk = 0;      //       %  .( Lots = 0)
extern int MartinType = 0;      //       . 0 -  
extern double KotLots = 1;      //    (MartinType = 1)
extern double StepLots = 0.02;  //    (MartinType = 2)
extern int    Slip    = 3;      //      
extern int    SL      = 30;     // 
extern int    TP      = 0;    // 
extern int    Magic   = 2552012; 
extern bool Close_ON  =  true; //      (false - )
//======================================      ==========================
extern int     BBUSize       = 15;    //        . 0 - .
extern int     BBUSizepip    = 10;    //  
extern string _P_STrailing = "----------   ";
extern bool Trail        = true;  //  ?
extern bool ProfitOnly   = true;  //   
extern int Trailing.Buy  = 30;    //      Buy
extern int TrStep.Buy    = 2;     //      Buy
extern int Trailing.Sell = 30;    //      Sell
extern int TrStep.Sell   = 2;     //      Sell
//======================================     ========================
extern bool GO = true;//  
//======================================     ==========================
extern   string A = "---  ---";
extern int  SignalBar    = 0;     //,     
extern bool Reverse      = false; //   (  buy ->  sell,  )
extern bool SignalType_1 = true;  //RSI, Stoch, CCI
extern bool SignalType_2 = true;  // MA2, Stoch, RSI, CCI,
extern bool SignalType_3 = true;  //IchiA, IchiB, CCI, RSI, Stoch

extern string A2 = "--- INDICATORS ---";
extern string I1 = "- RSI -";
extern int RSIperiod = 14;          //    . 
extern int RSI_price = PRICE_CLOSE; // .  

extern   string I2 = "- Stochastic -";
extern int Stoch_K       = 14;         //( )    %K. 
extern int Stoch_D       = 3;          //     %D. 
extern int Stoch_slowing = 3;          // . 
extern int Stoch_method  = MODE_EMA;   // .         (Moving Average). 
extern int Stoch_price   = PRICE_CLOSE;//    .      : 0 - Low/High  1 - Close/Close. 
extern int Stoch_mode    = MODE_MAIN;  //  .  

extern   string I3 = "- CCI -";
extern int CCI_period        = 14;            //    . 
extern int CCI_price = PRICE_TYPICAL; // .  

extern   string I5 = "- MA2 -";
extern int ma2_period = 200;           //     . 
extern int ma2_shift  = 0;           //    . 
extern int ma2_method = MODE_EMA;    // .
extern int ma2_price  = PRICE_CLOSE; // .  

extern   string I6 = "- iIchimoku -";
extern int tenkan        = 9;  //  Tenkan Sen. 
extern int kijun         = 26; //  Kijun Sen. 
extern int senkou_span_b = 52; //  Senkou Span B. 

//=================================     =============================
extern   string A7 = "---   ---";
extern int MaxCount  =  10;       //      ; -1 - 
extern int MaxBuyCount  =  10;    //      , -1 -   
extern int MaxSellCount  =  10;   //      , -1 -   

extern string soundManual = "Alert.wav"; //   
extern string soundOrder = "Alert.wav"; // "  "
//==============================================================================

datetime   BARflag  = 0;           //  
int i_buy =0, i_sell = 0;          //  
int NumberOfTry   = 3;             //  
int Kdig = 1;
double oldLots, newLots;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
int _digits;
   _digits = MarketInfo(Symbol(), MODE_DIGITS);
   if (_digits == 5 || _digits == 3 ) Kdig = 10; //       10    5-  
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
datetime now = Time[0];
int TypeCmd = -1;
//int TF1_Signal, TF2_Signal;
//int dir_X2MA = 0, dir_JJurX = 0; // +1 - Up; -1 - Dn
//int WorkReg; //  TF
bool CloseBuy = false, CloseSell = false;

    if(BBUSize>0) BBU();
    //
    if(Trail) {
      for (int i=0; i<OrdersTotal(); i++) {
          if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
              if (OrderSymbol()==Symbol() &&  (OrderMagicNumber( ) == Magic || Magic == 0)) SimpleTrailing();
      }
    }
    if(BARflag >= now) return(0);
    BARflag = now;
//   
    if(!CheckTradeTime(BeginSession, EndSession)) return(0); //   
//----
int    Sig = Signal();
    if(Sig == 1)
    {
        if(!Reverse) TypeCmd = OP_BUY;
        else TypeCmd = OP_SELL;
    }
    if(Close_ON && TypeCmd == OP_BUY) CloseSell = true;
    if(Sig == -1)
      {
         if(!Reverse) TypeCmd = OP_SELL;
         else TypeCmd = OP_BUY;
      }
    if(Close_ON && TypeCmd == OP_SELL) CloseBuy = true;
    
    
double TakeProfit, StopLoss, Price;
int nLots, nLoss;
double  lotstep;

    if(CloseBuy) CloseOrders(OP_BUY, Bid, Magic);
    if(CloseSell) CloseOrders(OP_SELL, Ask, Magic);
    
    if(TypeCmd < 0) return(0);
    nLots = ExistPositionsN(NULL,-1, Magic);
    if(MaxCount != -1 && nLots >= MaxCount) return(0); //
    if(Buy && TypeCmd == OP_BUY)
    {
        nLots = ExistPositionsN(NULL,TypeCmd, Magic);
        if(MaxBuyCount != -1 && nLots >= MaxBuyCount) return(0); //
        oldLots = GetLotLastClosePos(NULL, -1, Magic);
        newLots = CalcLot(MaxRisk);
        if(oldLots > 0) //     
        {
//            nLoss = TakeNumberClosePos(NULL, false, -1, Magic);
            nLoss = NumberLossPos(Magic);
            if(MartinType == 1) newLots = oldLots * KotLots; 
            else {
                if(MartinType == 2) newLots = CalcLot(MaxRisk) + StepLots * MathPow(2, nLoss - 1);
                else newLots = CalcLot(MaxRisk);
            }
        }
        oldLots = GetLotLastClosePosNULL(NULL, -1, Magic); 
        if(oldLots > 0) newLots = oldLots;    //      
        lotstep = MarketInfo(Symbol(),MODE_LOTSTEP);
        newLots = MathRound(newLots/lotstep)*lotstep;

        if(TP == 0) TakeProfit = 0;
        else
            TakeProfit = NormalizeDouble(Ask + TP * Kdig * Point, Digits);
        if(SL == 0) StopLoss = 0;
        else StopLoss = NormalizeDouble(Ask - SL * Kdig * Point, Digits);
        Price = NormalizeDouble(Ask, Digits);
    }
    if(Sell && TypeCmd == OP_SELL)
    {
        nLots = ExistPositionsN(NULL,TypeCmd, Magic);
        if(MaxSellCount != -1 && nLots >= MaxSellCount) return(0); //
        oldLots = GetLotLastClosePos(NULL, -1, Magic);
        newLots = CalcLot(MaxRisk);
        if(oldLots > 0) // , ..   
        {
//            nLoss = TakeNumberClosePos(NULL, false, -1, Magic); //  
            nLoss = NumberLossPos(Magic);
            if(MartinType == 1) newLots = oldLots * KotLots; 
            else {
                if(MartinType == 2) newLots = CalcLot(MaxRisk) + StepLots * MathPow(2, nLoss - 1);
                else newLots = CalcLot(MaxRisk);
            }
        }
        oldLots = GetLotLastClosePosNULL(NULL, -1, Magic); 
        if(oldLots > 0) newLots = oldLots;    //     
        lotstep = MarketInfo(Symbol(),MODE_LOTSTEP);
        newLots = MathRound(newLots/lotstep)*lotstep;

        if(TP == 0) TakeProfit = 0;
        else
            TakeProfit = NormalizeDouble(Bid - TP * Kdig * Point, Digits);
        if(SL == 0) StopLoss = 0;
        else StopLoss = NormalizeDouble(Bid + SL * Kdig * Point, Digits);
        Price = NormalizeDouble(Bid, Digits);
    }
int ret;    
string strTP,strSL;
    if(Manual) {
        PlaySound(soundManual);
        strTP = "\n"+DoubleToStr(TakeProfit,Digits);
        strSL = "\n"+DoubleToStr(StopLoss,Digits);
        ret=MessageBox(" "+GetNameOP(TypeCmd)+strTP+strSL+"\n?", "Question", MB_YESNO|MB_ICONQUESTION);
        if(ret==IDNO) return(0);
    }
    if(!MWMode)
        ySendOrder(TypeCmd,Price, TakeProfit, StopLoss);
    else
    {
        if(OrderSelect(ySendOrder(TypeCmd,Price, 0, 0), SELECT_BY_TICKET)==true)
        {
            if(OrderStopLoss( ) != StopLoss ||  OrderTakeProfit( ) != TakeProfit)
                    ModifyOrder(-1, StopLoss, TakeProfit);    
         }
    }
//----
   return(0);
}
//+------------------------------------------------------------------+
//
// < 0 - Dn
// > 0 - Up
int Signal()
{
double RSI = iRSI(NULL,15,RSIperiod,RSI_price,SignalBar);
double Stoch = iStochastic(NULL,15,Stoch_K,Stoch_D,Stoch_slowing,Stoch_method,Stoch_price,Stoch_mode,SignalBar);
double CCI = iCCI(NULL,15,CCI_period,CCI_price,SignalBar);

double MA2 = iMA(NULL,15,ma2_period,ma2_shift,ma2_method,ma2_price,SignalBar);
double IchiA = iIchimoku(NULL, 15, tenkan, kijun, senkou_span_b, 3, SignalBar);
double IchiB = iIchimoku(NULL, 15, tenkan, kijun, senkou_span_b, 4, SignalBar); 

    if(GO && SignalType_1 && RSI >= 65 && Stoch >= 80 && CCI >= 100) {GO=false; return(+1);}//   (+1);
    if(GO && SignalType_2 && Bid >= MA2 && RSI >= 65 && Stoch >= 80 && CCI>=100) {GO=false; return(+1);}//   return(+1);
    if(GO && SignalType_3 && Bid >= IchiA && RSI >= 65 && Stoch >= 80 && CCI>=100) {GO=false; return(+1);}//   (+1);
    
   

    
    if(GO && SignalType_1 && RSI <= 35 && Stoch <= 20 && CCI <= -100) {GO=false; return(-1);}//   (-1);
    if(GO && SignalType_2 && Ask <= MA2 && RSI <= 35 && Stoch <= 20 && CCI <= -100) {GO=false; return(-1);}//   (-1);
    if(GO && SignalType_3 && Ask <= IchiB && RSI <= 35 && Stoch <= 20&& CCI <= -100) {GO=false; return(-1);}//   (-1);
    return(0);
}


//+------------------------------------------------------------------+
bool CheckTradeTime(string _begin, string _end)
{
datetime beg, end, cur;
int b_hour = StrToInteger(StringSubstr(_begin, 0, 2));
int e_hour = StrToInteger(StringSubstr(_end, 0, 2));
    
    beg = StrToTime(_begin);
    end = StrToTime(_end);
    if(beg == end) return(true);
    if(b_hour > e_hour) {
        beg = beg - PERIOD_D1 * 60;
        if(Hour() >= b_hour) end = end + PERIOD_D1 * 60;
    }
    cur =TimeCurrent();
    if(cur > beg && cur < end) return(true);
    return(false);
}
//+------------------------------------------------------------------+
//   OP_BUYSTOP  OP_SELLSTOP,
// type -   BUYSTOP, SELLSTOP
// open -  ,
// stop -  . 

int ySendOrder(int _type,double _price, double _tp,double _sl)
{
int err;
string Type;
color clr;
   
   if(_type==OP_BUYSTOP) { Type = "OP_BUYSTOP"; clr = Blue; }
   if(_type==OP_SELLSTOP) { Type = "OP_SELLSTOP"; clr = Red; }
   if(_type==OP_BUY) { Type = "OP_BUY"; clr = Blue; }
   if(_type==OP_SELL) { Type = "OP_SELL"; clr = Red; }
   
   for (int it=0; it < NumberOfTry; it++) 
   {
      Print(" .  - ", it);
      err=OrderSend(Symbol(),_type,newLots,_price,Slip * Kdig,_sl,_tp,"",Magic,0,clr);  
      if(err<0)
      {
         Print("OrderSend()-   " + Type+"  price/Lot "+_price+"/"+newLots+" sl "+_sl+" tp "+_tp+" Error N "+GetLastError());
         Sleep(1000);
      }
      else {
        PlaySound(soundOrder);
        break;
      }
   }
   Sleep(500);
   return(err);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
//  color  cl=IIFc(OrderType()==OP_BUY
//              || OrderType()==OP_BUYLIMIT
//              || OrderType()==OP_BUYSTOP, clModifyBuy, clModifySell);
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);

  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
//      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex);
      if (fm) {
//        if (UseSound) PlaySound(SoundSuccess); break;
      } else {
        er=GetLastError();
//        if (UseSound) PlaySound(SoundError);
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        Print("Error(",er,") modifying order");
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
              
        Sleep(1000*10);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|   :                                     |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
int ExistPositionsN(string sy="", int op=-1, int mn=-1, datetime ot=0) 
{
  int i, k=OrdersTotal(), rez=0;
  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) rez = rez+1;
            }
          }
        }
      }
    }
  }
  return(rez);
}
//+----------------------------------------------------------------------------+
//|   :                                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    TipOrder -   ( OP_BUY || OP_SELL )                             |
//|    Price    -  TP                                           |
//|    Magic    - MagicNumber      (-1   -  )                        |
//+----------------------------------------------------------------------------+
bool CloseOrders(int TipOrder, double Price, int mn=-1)
{
int Norder;
int total = OrdersTotal(); 
            
   //----    
   for(int cnt = total - 1; cnt >= 0; cnt--)      //   
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);//      
      if( OrderSymbol()==Symbol())//    (       )
      {
         if(OrderType()==TipOrder)//  /
         {
            if (mn<0 || OrderMagicNumber()==mn) 
            {
               if(TipOrder == OP_BUY) Price = NormalizeDouble(Bid,Digits);
               if(TipOrder == OP_SELL) Price = NormalizeDouble(Ask,Digits);
               Norder = OrderTicket();
               OrderClose(OrderTicket(),OrderLots(),Price,3,Violet); // 
               

               Print("=======  =",Norder);
               // 
            }
         }
      }
   }
  } 


//+------------------------------------------------------------------+
int  BBU()
{//  http://fxnow.ru/blog/programming_mql4/2.html
int i;bool err;
double sl;
   for( i=1; i<=OrdersTotal(); i++) {     
      if(OrderSelect(i-1,SELECT_BY_POS)==true) {
        if(OrderSymbol()==Symbol() && (OrderMagicNumber()==Magic || Magic == 0)) {

            if(OrderType()==OP_BUY && OrderStopLoss()<OrderOpenPrice()) {
                if(Bid-OrderOpenPrice()>=BBUSize*Point) {
                    Print("  ");
                    sl = NormalizeDouble(OrderOpenPrice()+BBUSizepip*Point, Digits);
                    err=OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Green);
                    if(err==false) return(-1);
                }//if(Bid
            }//if(OrderType()
            
            if(OrderType()==OP_SELL && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0))  {
                if(OrderOpenPrice()-Ask>=BBUSize*Point) {
                    Print("  ");
                    sl = NormalizeDouble(OrderOpenPrice()-BBUSizepip*Point,Digits);
                    err=OrderModify(OrderTicket(),OrderOpenPrice(),sl,OrderTakeProfit(),0,Green);
                    if(err==false) return(-1);
                } //if(OrderOpenPrice()
            }//if(OrderType()
       
        }//if(OrderSymbol()
      }//if(OrderSelect(
    }// for( i=1;
    return(0);
}
//+----------------------------------------------------------------------------+
//|                                           |
//+----------------------------------------------------------------------------+
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//+----------------------------------------------------------------------------+
void SimpleTrailing() {
  double pa, pb, pp;

  pp=MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pb=MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitOnly || (pb-OrderOpenPrice())>Trailing.Buy*pp) {
      if (OrderStopLoss()<pb-(Trailing.Buy+TrStep.Buy-1)*pp) {
        ModifyOrder(-1, pb-Trailing.Buy*pp, -1);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) {
    pa=MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitOnly || OrderOpenPrice()-pa>Trailing.Sell*pp) {
      if (OrderStopLoss()>pa+(Trailing.Sell+TrStep.Sell-1)*pp || OrderStopLoss()==0) {
        ModifyOrder(-1, pa+Trailing.Sell*pp, -1);
        return;
      }
    }
  }
}
//+----------------------------------------------------------------------------+
//| :                                                                  |
//|          -1 |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetLotLastClosePos(string sy="", int op=-1, int mn=-1) {
  datetime o;
  double   l=-1;
  int      i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (o<OrderCloseTime()) {
                o=OrderCloseTime();
                if(OrderProfit() < 0) l=OrderLots();
                else l = -1;
              }
            }
          }
        }
      }
    }
  }
//  Print("   = ",l);
  return(l);
}
//|            -1 |
double GetLotLastClosePosNULL(string sy="", int op=-1, int mn=-1) {
  datetime o;
  double   l=-1;
  int      i, k=OrdersHistoryTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (o<OrderCloseTime()) {
                o=OrderCloseTime();
                if(OrderProfit() == 0) l=OrderLots();
                else l = -1;
              }
            }
          }
        }
      }
    }
  }
  return(l);
}
//+------------------------------------------------------------------+
//extern int  MaxRisk=2;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
double CalcLot(double _MaxRisk)
{
//--
double Free =AccountFreeMargin();
//double Free =AccountBalance();
double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
double Step =MarketInfo(Symbol(),MODE_LOTSTEP);
double Min_Lot =MarketInfo(Symbol(),MODE_MINLOT);
double Max_Lot =MarketInfo(Symbol(),MODE_MAXLOT);
double CLot;
    if(_MaxRisk > 0) CLot =MathFloor(Free*_MaxRisk/100/One_Lot/Step)*Step;
    else CLot = Lots;
    if(CLot<Min_Lot) CLot=Min_Lot;
    if(CLot>Max_Lot) CLot=Max_Lot;
    return(CLot);
}
///+----------------------------------------------------------------------------+
//|   :                       |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//+----------------------------------------------------------------------------+
int NumberLossPos(int mn) {
int total_loss=0;
   if (OrdersHistoryTotal() != 0)
   {
      for (int k = OrdersHistoryTotal()-1; k >= 0; k--)
      {
         OrderSelect(k,SELECT_BY_POS, MODE_HISTORY);
         if (OrderSymbol() == Symbol() && OrderMagicNumber() == mn)
         {
            if (OrderType() == OP_BUY || OrderType() == OP_SELL)
            {
               if (OrderProfit() < 0)
               {
                  total_loss++;
               }
               else
               {
                  if (OrderProfit() > 0)
                     {
                          break;
                     }
               }
            }
         }
      }
   }
   return(total_loss);
}          